﻿namespace DependencyPropertySerialization
{
    using System.Collections.Generic;
    using System.Runtime.Serialization;

    public class GraphNodeBase : SerializableDependencyObject
    {
        #region Graph Node Members
        protected List<GraphNodeBase> mChildren;
        protected GraphNodeBase mParent;
        #endregion

        #region Constructors
        public GraphNodeBase(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        public GraphNodeBase(GraphNodeBase _parent)
        {
            mChildren = new List<GraphNodeBase>();
            mParent = _parent;
            if (null != mParent)
            {
                mParent.AddChild(this);
            }
        }
        #endregion

        public void AddChild(GraphNodeBase newChild)
        {
            mChildren.Add(newChild);
        }
    }
}
