﻿namespace WPFDependencyPropertySerializationError
{
    using System;
    using System.Runtime.Serialization;

    class MySurrogateSelector : ISurrogateSelector
    {
        ISurrogateSelector mNextSelector;
        ReflectionSerializationSurrogate mSurrogate = new ReflectionSerializationSurrogate();

        #region ISurrogateSelector Members
        public void ChainSelector(ISurrogateSelector selector)
        {
            mNextSelector = selector;
        }

        public ISurrogateSelector GetNextSelector()
        {
            return mNextSelector;
        }

        public ISerializationSurrogate GetSurrogate(Type type, StreamingContext context, out ISurrogateSelector selector)
        {
            if (type.IsSubclassOf(typeof(SerializableDependencyObject)))
            {
                selector = this;
                return mSurrogate;
            }

            selector = null;
            return null;
        }

        #endregion
    }
}
